// 
{*******************************************************}
{                                                       }
{                E L E K S   W I Z A R D S              }        
{                                                       }
{        Copyright (C) 1998, 1999 Eleks Software        }
{               Created by Yuri Solodkiy                }
{                                                       }
{                 http://eleks.txnet.com                }
{                    eleks@txnet.com                    }
{                   gerasika@yahoo.com                  }                            
{                                                       }
{*******************************************************}


// $Archive: /H/Gerix/Projects/elWizards/elWizardsPage.pas $ $Author: Gerix $ $Date: 19.08.99 12:49 $ $Revision: 7 $ $Workfile: elWizardsPage.pas $

unit elWizardsPage;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TelComponentList = class;

  TelComponentListInsertNotifyEvent = procedure (Sender: TelComponentList; Comp: TComponent) of object;
  TCompProc = procedure(Value: TComponent) of object;

  TelComponentList = class(TComponent)
  private
{  }
  protected
    { Protected declarations }
    FList: TStringList;
    procedure Loaded; override;
    procedure WriteState(Writer: TWriter); override;
    procedure AssignTo(Dest: TPersistent); override;
    procedure Notification(Comp: TComponent; Op: TOperation); override;

    procedure DoInsert(Index: integer; Value: TComponent); virtual;
    function DoAdd(Value: TComponent): integer; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure Clear; virtual;
    function Add(Value: TComponent): integer;
    procedure Insert(Index: integer; Value: TComponent);
    procedure Remove(Value: TComponent); virtual;
    procedure Delete(Index: integer); virtual;
    procedure ForEach(Proc: TCompProc);

    property Count: integer read GetCount;
    property Items[Index: integer]: TComponent read GetItems write SetItems; default;
    property IndexOf[Comp: TComponent]: integer read GetIndexOf;
    property Exists[C: TComponent]: boolean read GetExists;
  published
    property Components: TStringList read FList write SetList stored true;
    property OnInsert: TelComponentListInsertNotifyEvent read FOnInsert write FOnInsert;
  end;

  TelWizardPageList = class(TelComponentList)
  private
{  }
  protected
    procedure SetOnCancel(Value: TNotifyEvent);
    procedure SetOnFinish(Value: TNotifyEvent);
  public
  published
    property OnCancel: TNotifyEvent read FOnCancel write SetOnCancel;
    property OnFinish: TNotifyEvent read FOnFinish write SetOnFinish;
  end;

  TelWizardPage = class;
  TelWizardPage_ = class;

  TWizardPageValidateEvent = function (Page: TelWizardPage_; var Reason: string): boolean of object;

  TelWizardPage_ = class(TPanel)
  private
{  }
  protected
    procedure Notification(Comp: TComponent; Op: TOperation); override;
  public
    constructor Create(theOwner: TComponent); override;
    procedure Clear;
    procedure ValidateNext;
    procedure Enter; dynamic;
    procedure Next; dynamic;
    procedure Back; dynamic;
    function Validate(out Reason: string): boolean; dynamic;
    property NilOverride: TelWizardPage read FNilOverride write FNilOverride;
    property OnUpdateButtons: TNotifyEvent read FOnUpdateButtons write FOnUpdateButtons;
  published
    property OnFirstEnter: TNotifyEvent read FOnfirstenter write FOnFirstEnter;
    property OnEnter: TNotifyEvent read FOnEnter write FOnEnter;
    property OnNext: TNotifyEvent read FOnNext write FOnNext;
    property OnBack: TNotifyEvent read FOnBack write FOnBack;
    property OnValidate: TWizardPageValidateEvent read FOnValidate write FOnValidate;
    property NextPage: TelWizardPage read FNextPage write SetNextPage;
    property BackPage: TelWizardPage read FBackPage write SetBackPage;
    property Title: string read FTitle write FTitle;
  end;

  TelWizardPage = class(TelWizardPage_)
  end;


implementation

{  }

end.

